<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2008 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


include_once "include/config.php";
include_once "include/tools.php";
include_once "include/mime.php";
;
include_once "include/common.php";
include_once "include/site.php";

$select_folder   = pg_escape_string($_REQUEST['select_folder']);
$select_album    = pg_escape_string($_REQUEST['select_album']);

$selection       = $_REQUEST['selection'];

$database = site_prolog(PO_USER_TYPE_USER);

if (!$selection) {
  site_push_error($strings['errors']['invalid_operation']);
  site_epilog($database);
  header("Location: my.tools.php?selector=".$tools_data['content_indexer']['idx']);
 }

$type = $_REQUEST['type'];
switch ($type) {
 case "layout":
   $index_algorithm = "ar_index_haar:0.2.0";
   break;
 case "color":
   $index_algorithm = "ar_index_histogram:0.1.0";
}

site_header($strings['generic']['content_indexer']);
site_navigator(10);
site_navigator_status(emit_a(generate_link('user', ''), $strings['generic']['users'])." : ".$strings['generic']['content_indexer'], "");

theme_display_navigator_box_top($tools_data['content_indexer']['idx'], $tools_data, "100%");

if ($po_user['type'] != PO_USER_TYPE_ADMIN) {
  $user_sel = " and users = $po_user[id]";
} else {
  $user_sel = "";
}

switch ($selection) {
 case 'folder':
  if ($select_folder == "all")
    $sql_selector = " users = $po_user[id] ";
  else
    $sql_selector = " folder = $select_folder $user_sel";
  break;
 case 'album':
  $sql_selector = " identifier in( select photo from album_content where album = $select_album) $user_sel";
  break;
 case 'spool':
   $sql_selector = " identifier in( select photo from album_content where album = $po_user[spool_album]) $user_sel";
  break;
 default:
   header("Location: my.tools.php?selector=5");
   exit();
   break;
}

$all_photos = pg_query($database, "
  select identifier from photo
   where $sql_selector
     and access_rights = $access[public]");

$num_of_updates = pg_num_rows($all_photos);
for ($i=0; $i < $num_of_updates; $i++) {
  $photo = pg_fetch_row($all_photos, $i);
  submit_photo($database, $photo[0], $index_algorithm);
}

print "<p align=\"left\">".$strings['tools']['num_photos_indexed']." : $num_of_updates</p>";

print "<p>";
print $thm_elem['button.back'];
print "</p>";


theme_display_navigator_box_bottom("100%");

site_footer($database);
site_epilog($database);



?>
