<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2008 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/mime.php";
include_once "include/common.php";
include_once "include/site.php";
include_once "include/export.php";
include_once "include/orderby.php";

$compress_pages = false;   /* Explicitly disable it here */

$database = site_prolog(PO_USER_TYPE_USER);

$export_type       = $_REQUEST['export_type'];
$export_format     = $po_options['export_format'];

/* Are we asking for the tarball? */
if (isset($_REQUEST['export_id'])) {
  $export_id = $_REQUEST['export_id'];
  $file_name = $tmp_volume_path . "/po.export.$export_id.$export_format";

  $file = fopen($file_name , "rb");
  if ($file == false) {
    header("HTTP/1.1 404 Not found");
    exit();
  }

  $stats = stat($file_name);
  
  header("Content-Length: $stats[7]");
  switch ($export_format) {
  case 'tar':
    header("Content-Type: application/tar");
    break;
  case 'zip':
    header("Content-Type: application/zip");
    break;
  }
  header("Content-Disposition: filename=po.export." . date(DATE_W3C, $stats[9]) . ".$export_format");
  
  /* read 1M chunks */
  while (!feof($file)) {
    echo fread($file, 1*(1024*1024));
  }
  
  fclose($file);
  unlink($file_name);
  
  site_epilog($database);
  exit();
 }

/* Time to generate a tarball */
$photos_in_spooler = pg_query($database, "
  select photo as identifier from album_content where album = $po_user[spool_album] group by photo order by photo");

$num_photos = pg_num_rows($photos_in_spooler);

site_header($strings['generic']['export']);
site_navigator(5);
site_navigator_status("", $strings['spool']['photos_in'] .": $num_photos");

print "<div align=\"left\">";
print "<p>".sprintf($strings['export']['exporting'], "<strong>$num_photos</strong>")."</p>\n";

$temporary_directory = tempnam($tmp_volume_path, "po.export.");
unlink($temporary_directory);

$export_id = basename($temporary_directory);
$export_id = substr($export_id, strlen("po.export."));

print "<ul>";
print "<li>" . sprintf($strings['import']['creating_temp_dir']);
$old_mask = umask(0000);
if (!mkdir($temporary_directory)) {
  print err_str(" - $temporary_directory - ". $strings['generic']['failed']);
} 
print "</li>";

switch($export_type) {
 case "photo":
 case "photo_xml_iptc":
 case "photo_iptc":
 default:
   break;
 case "photo_xml":
   print "<li>".$strings['export']['create_xml'];
   if (($xml_file_desciptor = fopen ($temporary_directory."/data.xml", "w+")) == FALSE) {
     print err_str($strings['generic']['failed']);
   }
   print "</li>";

   fwrite($xml_file_desciptor, create_xml_header());
   fwrite($xml_file_desciptor, create_xml_bulkupload_header());
   break;
}

switch ($export_format) {
 case 'tar':
   /* creates the tar archive */
   $exp_file_name = $temporary_directory . ".tar";
   break;
 case 'zip' :
   chdir($temporary_directory);
   $exp_file_name = $temporary_directory . ".zip";
   break;
 } 

for ($photos = 0; $photos < $num_photos; $photos++) {
  $photo_identifier = pg_fetch_assoc($photos_in_spooler, $photos);

  /* optimize query, by excluding fields that are not used when not exporting shooting data */
  switch($export_type) {
  case "photo_xml_iptc":
  case "photo_iptc":
  case "photo_xml":
    $photo_data = pg_fetch_assoc(pg_query($database, "
       select folder, author, title, caption, caption_writer, copyright_statement, web_statement, date_of_exposure, category, supplemental_category,
              location, storage_location, storage_index, credit, source,
              access_rights, hide_original, headline, instructions,
              camera, film, focal_length, aperture, shutter, transmission_reference,
              exposure_comp, ev_difference, camera_metering, camera_program, flash_mode, flash_comp,
              scan_resolution, scan_bitdepth, scan_multiscan, iso_override,
              latitude, longitude, altitude, img_direction, users, can_access_photo(photo.identifier, $po_user[id], '{".$passwords."}') as ok,
              store_url, photo.comments as remark
         from photo, photo_version, photo_tech, photo_dupe
        where photo.identifier = photo_version.photo
          and photo.identifier = photo_dupe.photo
          and photo.identifier = photo_tech.photo
          and photo.identifier = $photo_identifier[identifier]
          and photo_dupe.key = 1"));


    /* If we can't access the original or access the image... */
    if (($photo_data['users'] != $po_user['id']) &&
	!($po_user['type'] == PO_USER_TYPE_ADMIN)) {
      if (($photo_data['ok'] != 't') || ($photo_data['hide_original'] != 't')) {
	continue 2;
      }
    }
    
    /* Get any keywords for the photo... */
    $keywords = get_photo_keywords($database, $photo_id);

    $res = pg_query($database, "select photo, equipment, type from photo_equipment where photo = $photo_identifier[identifier] order by photo, type");
    $equipment = FALSE;
    for ($i=0; $i < pg_num_rows($res); $i++) {
      $dat = pg_fetch_assoc($res);
      $equipment[] = "$dat[equipment]:$dat[type]";
    }

    break;
  case "photo":
  default:
    $photo_data = pg_fetch_assoc(pg_query($database, "select users, hide_original, title, can_access_photo(photo.identifier, $po_user[id], '{".$passwords."}') as ok from photo where identifier = $photo_identifier[identifier]"));
    /* Make sure we can access it! */
    if (($photo_data['users'] != $po_user['id']) &&
	!($po_user['type'] == PO_USER_TYPE_ADMIN)) {
      if (($photo_data['ok'] != 't') || ($photo_data['hide_original'] != 't')) {
	continue 2;
      }
    }
    break;
  }

  $photo_version_data = pg_query($database, "
     select get_image_path(photo_version.identifier, 0) as original_path, original_image_name, comment, master, get_image_path(photo_version.identifier, -1) as sidecar_path
       from photo_version
      where photo_version.photo = $photo_identifier[identifier]");

  $title = $photo_data['title'];
  if ($title == "")
    $title = $strings['photo']['no_title'] ." - $photo_identifier[identifier]";

  print "<li>" . $strings['export']['image'] . ($photos + 1) . "/$num_photos - ".emit_a(generate_link('photo', $photo_identifier['identifier']), $title) .".";

  /* Generate filename list */
  for ($versions = 0; $versions < pg_num_rows($photo_version_data); $versions++) {
    $photo_version_single = pg_fetch_assoc($photo_version_data, $versions);

    $file_name = $image_repository_path."/".$photo_version_single['original_path'];
    $xmp_name = $image_repository_path."/".$photo_version_single['sidecar_path'];

    $original_name = $temporary_directory."/".$photo_version_single['original_image_name'];

    print "<ul>";

    /* check for the source file's existence */
    if (!is_file($file_name)) {
      print "<li>". err_str($strings['errors']['file_not_found']) ." : ". sprintf($strings['export']['skipped'],emit_a(generate_link('photo', $photo_identifier['identifier']), $title))  . "</li>";
      print "</ul>";
      continue;
    }

    print "<li>".sprintf($strings['export']['adding'], $photo_version_single['original_image_name']);
    exec("ln -s \"$file_name\" \"$original_name\"", $who_cares, $retval_tar);
    if (is_file($xmp_name)) {
      exec("ln -s \"$xmp_name\" \"$original_name.xmp\"", $who_cares, $retval_tar);
    }

    /* we use "exec" instead of "system" to avoid unwanted output */
    if ($retval_tar) {
      print err_str($strings['generic']['failed']);
      print "</li>";
    } else {
      print "</li>";
    }
    print "</ul>";
  }
  print "</li>";

  /* export shooting data */
  switch($export_type) {
  case "photo":
  default:
    break;
  case "photo_xml":
    $image_data = array ("file" => array(0 => array("name" => "", "remark" => "", "master" => "")),
                         "folder"                => $photo_data['folder'],
                         "author"                => $photo_data['author'],
                         "title"                 => $photo_data['title'],
                         "keywords"              => $keywords,
                         "caption"               => $photo_data['caption'],
                         "caption_writer"        => $photo_data['caption_writer'],
                         "credit"                => $photo_data['credit'],
                         "source"                => $photo_data['source'],
                         "headline"              => $photo_data['headline'],
                         "instructions"          => $photo_data['instructions'],
                         "transmission_reference"          => $photo_data['transmission_reference'],
                         "category"              => $photo_data['category'],
                         "supplemental_category" => $photo_data['supplemental_category'],
                         "copyright"             => $photo_data['copyright_statement'],
                         "web_statement"         => $photo_data['web_statement'],
                         "date_of_exposure"      => $photo_data['date_of_exposure'],
                         "location"              => $photo_data['location'],
                         "storage_location_type" => $photo_data['storage_location'],
                         "storage_location_id"   => $photo_data['storage_location'],
                         "storage_index"         => $photo_data['storage_index'],
                         "access_rights"         => $photo_data['access_rights'],
                         "hide_original"         => $photo_data['hide_original'],
                         "camera"                => $photo_data['camera'],
                         "film"                  => $photo_data['film'],
                         "focal_length"          => $photo_data['focal_length'],
                         "aperture"              => $photo_data['aperture'],
                         "shutter"               => $photo_data['shutter'],
                         "exp_comp"              => $photo_data['exposure_comp'],
                         "exp_diff"              => $photo_data['ev_difference'],
                         "camera_metering"       => $photo_data['camera_metering'],
                         "camera_program"        => $photo_data['camera_program'],
                         "flash_mode"            => $photo_data['flash_mode'],
                         "flash_comp"            => $photo_data['flash_comp'],
                         "scan_resolution"       => $photo_data['scan_resolution'],
                         "scan_bitdepth"         => $photo_data['scan_bitdepth'],
                         "scan_multiscan"        => $photo_data['scan_multiscan'],
                         "iso_override"          => $photo_data['iso_override'],
                         "latitude"              => $photo_data['latitude'],
                         "longitude"             => $photo_data['longitude'],
                         "altitude"              => $photo_data['altitude'],
                         "direction"             => $photo_data['img_direction'],
			 "store_url"             => $photo_data['store_url'],
			 "equipment"             => $equipment,
			 "remark"                => $photo_data['remark']);

    for ($versions = 0; $versions < pg_num_rows($photo_version_data); $versions++) {
      $photo_version_single = pg_fetch_assoc($photo_version_data, $versions);
      $image_data['file'][$versions]['name']   = $photo_version_single['original_image_name'];
      $image_data['file'][$versions]['remark'] = $photo_version_single['comment'];
      $image_data['file'][$versions]['master'] = $photo_version_single['master'];
    }

    fwrite($xml_file_desciptor, create_xml_folder_header($image_data['folder']));
    fwrite($xml_file_desciptor, create_xml_photo($image_data));
    fwrite($xml_file_desciptor, create_xml_folder_footer());
    print "<li>".$strings['export']['append_xml']."</li>";
    break;
  case "photo_xml_iptc":
  case "photo_iptc":
    print "<li>".err_str($strings['errors']['iptc_not_implemented'])."</li>";
  }

  flush();

 }

switch($export_type) {
 case 'photo':
 case 'photo_iptc':
 case 'photo_xml_iptc':
 default:
   break;
 case 'photo_xml':
   print "<li>".$strings['export']['close_xml']."</li>";
   fwrite($xml_file_desciptor, create_xml_bulkupload_footer());
   fclose($xml_file_desciptor);
   break;
}

print "<li>".$strings['export']['creating_archive']. "...";

/* Create the acual archive from symlink list */
switch ($export_format) {
 case 'tar':
   $command = $sys_tar." -cf \"$exp_file_name\" -h -C \"$temporary_directory\" . ";
   /* from now on, append to the tar archive */
   break;
 case 'zip':
   $command = $sys_zip." -D -r -0 \"$exp_file_name\" . ";
   break;
 } 

/* we use "exec" instead of "system" to avoid unwanted output */
exec($command, $who_cares, $retval_tar);
if ($retval_tar) {
  print err_str($strings['generic']['failed']);
  print "</li>";
  return false;
 } else {
  print "</li>";
 }

print "<li>".sprintf($strings['import']['removing_temp_dir']);
if (!deltree($temporary_directory)) {
  print err_str(" - $temporary_directory - " . $strings['generic']['failed']);
}
print "</li>";

print "</ul>\n";

umask($old_mask);
print "<h3>".$strings['export']['finished']."</h3>";

print sprintf($strings['export']['download'], "<a href=\"export.php?export_id=$export_id&amp;export_format=$export_format\">".$strings['generic']['here']."</a>");

print "</div>\n";

site_footer($database);
site_epilog($database);
?>
