<?php

//  Copyright (C) 2002-2006 Balint Kis (balint@k-i-s.net)
//  Copyright (C) 2005-2008 Solomon Peachy (pizza@shaftnet.org)

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

include_once "include/config.php";
include_once "include/common.php";
include_once "include/site.php";

$database = site_prolog(PO_USER_TYPE_USER);

$album_id = isset($_REQUEST['album']) ? pg_escape_string($_REQUEST['album']) : FALSE;
$action = isset($_REQUEST['action']) ? $_REQUEST['action'] : 'add';
$go = isset($_REQUEST['go']);
$size = isset($_REQUEST['size']) ? pg_escape_string($_REQUEST['size']) : 2;

switch($action) {
 case 'add':
   $photo_id   = pg_escape_string($_REQUEST['photo']);
   $version  = pg_escape_string($_REQUEST['version']);
 
   $photo_original = pg_fetch_row(pg_query($database, "select storage_location, storage_index from photo_dupe where photo=$photo_id and key=1"));

   break;
 case 'edit':
   $dupe_id  = pg_escape_string($_REQUEST['dupe']);

   $photo_dupe  = pg_fetch_row(pg_query($database, "select date_of_creation, storage_location, storage_index, remark, version, photo from photo_dupe where identifier='$dupe_id'"));

   $photo_id = $photo_dupe[5];
   $version = $photo_dupe[4];

   break;
 case 'delete':
   $dupe_id  = pg_escape_string($_REQUEST['dupe']);
   $photo_dupe = pg_fetch_row(pg_query($database, "select key, date_of_creation, storage_location, storage_index, remark, version, photo from photo_dupe where identifier=$dupe_id order by date_of_creation"));
   
   $photo_id = $photo_dupe[6];
   $version = $photo_dupe[5];

   break;
 }
   
$photo_data = pg_fetch_row(pg_query($database, "
  select caption, get_image_path(photo_version.identifier, 2) as preview_path, users, title, folder, original_image_name
    from photo, photo_version
   where photo.identifier = photo_version.photo
     and photo_version.identifier = $version
     and photo.identifier = '$photo_id'"));

/* Ensure mere users don't move/mangle a photo that isn't theirs! */
if ($photo_data[2] != $po_user['id'] && 
    $po_user['type'] != PO_USER_TYPE_ADMIN) {
  site_referer_error('not_owner');
  site_epilog($database);
  exit();
}

if ($go) {
  $result = FALSE;
  switch ($action) {
  case 'add':
    $storage_location = pg_escape_string($_REQUEST['storage_location']);
    $storage_index    = pg_escape_string($_REQUEST['storage_index']);
    $remark           = pg_escape_string($_REQUEST['remark']);

    $key = pg_fetch_row(pg_query($database, "select max(key) from photo_dupe where photo=$photo_id"));
    $key[0] += 1;
    $result = pg_query($database, "insert into photo_dupe (identifier, key, photo, storage_location, storage_index, remark, version)
                     values (nextval('photo_dupe_id_sequence'), '$key[0]', '$photo_id', '$storage_location', '$storage_index', '$remark', $version)");
    
    break;
  case 'edit':
    $storage_location = pg_escape_string($_REQUEST['storage_location']);
    $storage_index    = pg_escape_string($_REQUEST['storage_index']);
    $remark           = pg_escape_string($_REQUEST['remark']);
    $date_of_creation = check_date_validity(pg_escape_string($_REQUEST['creation_timestamp']));

    $result = pg_query($database, "
    update photo_dupe
       set date_of_creation=$date_of_creation,
           storage_location='$storage_location',
           storage_index='$storage_index',
           remark='$remark'
     where identifier='$dupe_id'");

    break;
  case 'delete':
    $result = pg_query($database, "delete from photo_dupe where identifier='$dupe_id' and remark != 'Original'");
    break;
  }
  if (!$result) {
    site_push_error($strings['errors']['db_insert_failed']);
  }
  site_epilog($database);
  header("Location: ".generate_link('photo', $photo_id, array('ver'=>$version, 'detail_info'=>3,'album'=>$album_id), TRUE));
  exit();
 }

$user_display_string = disp_user_string($database, $photo_data[2]);

site_header(sprintf($strings['profile'][$action], $strings['photo']['dupe']));
site_navigator(5);

$path_to_folder = get_path_to_folder($database, $photo_data[4]);
$title = get_photo_title($photo_data[0], $photo_data[3], $photo_data[5]);
site_navigator_status("$user_display_string $path_to_folder : ".emit_a(generate_link('photo', $photo_id, array('ver'=>$version, 'detail_info'=>5,'album'=>$album_id)), $title)." : ". sprintf($strings['profile'][$action], $strings['generic']['dupe']), "");

print "<div align=\"center\">\n";
theme_display_photo(generate_link('image', $photo_id, array('ver'=>$version, 'size'=>$size)), "", $image_repository_path . "/" . $photo_data[1]);
print "</div>\n";

switch($action) {
 case 'add':
   print "<form method=\"post\" action=\"photo.dupe.php\" accept-charset=\"".$strings['formats']['encoding']."\">\n";
   print "<input type=\"hidden\" name=\"photo\" value=\"$photo_id\" />\n";
   print "<input type=\"hidden\" name=\"version\" value=\"$version\" />\n";
   print "<input type=\"hidden\" name=\"go\" value=\"go\"/>\n";
   if ($album_id) {
     print "<input type=\"hidden\" name=\"album\" value=\"$album_id\"/>\n";
   }
   print "<input type=\"hidden\" name=\"action\" value=\"add\"/>\n";
   print "<table class=\"profile\">\n";
   print "<tr>";
   print emit_th($strings['import']['storage_location'], "colspan=\"2\" width=\"25%\"");
   print emit_th($strings['generic']['remark'], "width=\"50%\"");
   print "</tr>";
   
   print "<tr>";
   print "<td><input type=\"text\" name=\"storage_location\" value=\"$photo_original[0]\" /></td><td><input type=\"text\" name=\"storage_index\" value=\"$photo_original[1]\" /></td>";
   print "<td><input type=\"text\" name=\"remark\" /></td>\n";
   print "</tr>";
   
   print "</table>\n";
   print "<center>";
   print $thm_elem['button.add.duplicate'];
   print $thm_elem['button.cancel'];
   print "</center>";
   print "</form>\n";
   break;
 case 'edit':
   print "<form method=\"post\" action=\"photo.dupe.php\" accept-charset=\"".$strings['formats']['encoding']."\">\n";
   print "<input type=\"hidden\" name=\"photo\" value=\"$photo_id\"/>\n";
   print "<input type=\"hidden\" name=\"version\" value=\"$version\"/>\n";
   print "<input type=\"hidden\" name=\"dupe\" value=\"$dupe_id\"/>\n";
   print "<input type=\"hidden\" name=\"go\" value=\"go\"/>\n";
   if ($album_id) {
     print "<input type=\"hidden\" name=\"album\" value=\"$album_id\"/>\n";
   }
   print "<input type=\"hidden\" name=\"action\" value=\"edit\"/>\n";
   print "<table class=\"profile\">\n";
   print "<tr>";
   print emit_th($strings['generic']['created'], "width=\"20%\"");
   print emit_th($strings['import']['storage_location'], "colspan=\"2\" width=\"25%\"");
   print emit_th($strings['generic']['remark'], "width=\"55%\"");
   print "</tr>";
   print "<tr>";
   print "<td>\n";
   print emit_date_input_form("creation_timestamp", $photo_dupe[0]);
   print "</td>\n";
   print "<td><input type=\"text\" name=\"storage_location\" value=\"$photo_dupe[1]\"/></td>";
   print "<td><input type=\"text\" name=\"storage_index\" value=\"$photo_dupe[2]\"/></td>";
   print "<td><input type=\"text\" name=\"remark\" value=\"$photo_dupe[3]\"/></td>\n";
   print "</tr>";
   print "</table>\n";   
   print "<center>";   
   print $thm_elem['button.save.changes'];
   print $thm_elem['button.clear'];
   print $thm_elem['button.cancel'];
   print "</center>";
   print "</form>\n";
   break;
 case 'delete':
   print "<form method=\"post\" action=\"photo.dupe.php\" accept-charset=\"".$strings['formats']['encoding']."\">\n";
   print "<input type=\"hidden\" name=\"photo\" value=\"$photo_id\"/>\n";
   print "<input type=\"hidden\" name=\"version\" value=\"$version\"/>\n";
   print "<input type=\"hidden\" name=\"dupe\"  value=\"$dupe_id\"/>\n";
   print "<input type=\"hidden\" name=\"go\" value=\"go\"/>\n";
   if ($album_id) {
     print "<input type=\"hidden\" name=\"album\" value=\"$album_id\"/>\n";
   }
   print "<input type=\"hidden\" name=\"action\" value=\"delete\"/>\n";
   print "<table class=\"profile\">\n";
   print "<tr>";
   print emit_th($strings['photo']['dupe_id'], "width=\"5%\"");
   print emit_th($strings['generic']['created'], "width=\"15%\"");
   print emit_th($strings['import']['storage_location'], "width=\"25%\"");
   print emit_th($strings['generic']['remark'], "width=\"55%\"");
   print "</tr>";
   
   print "<tr>";
   print "<td>$photo_id-$photo_dupe[0]</td>";
   print "<td>\n".emit_date_html($photo_dupe[1], "date"). "</td>\n";
   print "<td>$photo_dupe[2]:$photo_dupe[3]</td>";
   print "<td>$photo_dupe[4]</td>\n";
   print "</tr>";
   print "</table>\n";
   
   print "<center>";
   print $thm_elem['button.confirm.delete'];
   print $thm_elem['button.cancel'];
   print "</center>";
   print "</form>\n";
   break;
 }

site_footer($database);
site_epilog($database);
?>
